local options = {
    
    max_hit = 44,
    max_res = 18,
    pet = true,
    
    ignore = {
    },
	
    rcvDmg = {
		enabled = true;
	},
	
    healing = {
        hots = true,
        heals = true,
        threshold = {
            enabled = true,
            value = 1200,
        },
    },
    
    damaging = {
        dots = true,
        damage = true,
        threshold = {
            enabled = true,
            value = 1400,
        },
    },
}
local playerGUID = UnitGUID("player")
local petGUID = UnitGUID("pet")
local MSG_CRITICAL_HIT = "Your critically hit for %d damage!"

local smb = CreateFrame("Frame");
smb:RegisterEvent("VARIABLES_LOADED");
smb:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED");
smb:SetScript("OnEvent", function(self, event)
	self:OnEvent(self, CombatLogGetCurrentEventInfo())
end)
function thresholdCheckHeal(inputType,dmgHeal)
    if ((options.healing.threshold.enabled and dmgHeal >= options.healing.threshold.value) or not options.healing.threshold.threshold.enabled) then
        return true    
    else
        return false
    end
end

function thresholdCheckDmg(dmgHeal)
    if ((options.damaging.threshold.enabled and dmgHeal >= options.damaging.threshold.value) or not options.damaging.threshold.enabled) then
        return true    
    else
        return false
    end
end

function subeventCheckRcvdDmg(e, dmgHeal)
    if ((e == "SWING_MISSED" or e == "SPELL_MISSED" or e == "RANGE_MISSED" or e == "SPELL_PERIODIC_MISSED")) then
		return true
	else
		return false
	end
end

function smb:OnEvent(e,...)
    local timestamp, subevent, _, sourceGUID, sourceName, sourceFlags, sourceRaidFlags, destGUID, destUnit, destFlags, destRaidFlags = ...
	local spellId, spellName, spellSchool
	local dmgHeal, overkill, school,isHealCrit_orDmgResisted,isDmgBlocked,isDmgAbsorbed,isDmgCrit, glancing, crushing, isOffHand
	
	if subevent == "SWING_DAMAGE" or  subevent == "DAMAGE_SHIELD" then
		dmgHeal, overkill, school, isHealCrit_orDmgResisted, isDmgBlocked, isDmgAbsorbed, isDmgCrit, glancing, crushing, isOffHand = select(12, ...)
	elseif subevent == "SPELL_DAMAGE" or subevent == "SPELL_PERIODIC_DAMAGE" or subevent == "RANGE_DAMAGE" then
		spellId, spellName, spellSchool, dmgHeal, overkill, school, isHealCrit_orDmgResisted, isDmgBlocked, isDmgAbsorbed, isDmgCrit, glancing, crushing, isOffHand = select(12, ...)
	elseif subevent == "SPELL_HEAL" or subevent == "SPELL_PERIODIC_HEAL" then
		spellId, spellName, spellSchool, dmgHeal, overkill, school, isHealCrit_orDmgResisted = select(12, ...)
	end
	
	if ( (playerGUID  == sourceGUID or (petGUID  == sourceGUID and options.pet)) and isHealCrit_orDmgResisted) then
		if ((subevent == "SPELL_HEAL" and options.healing.heals) or (subevent == "SPELL_PERIODIC_HEAL" and options.healing.hots)) then	
			if thresholdCheckHeal(dmgHeal) then
				PlaySoundFile("Interface\\AddOns\\SlapMeBoiiiiii\\AUDIO\\hit\\slap-"..tostring(math.random(1,options.max_hit))..".ogg","master")
				return true
			end
        end
	end
    if ( (playerGUID  == sourceGUID or (petGUID  == sourceGUID and options.pet)) and isDmgCrit) then
        --if (subeventCheck(subevent,dmgHeal)) then
		if ((subevent == "SPELL_PERIODIC_DAMAGE" and options.damaging.dots) or ((subevent == "SPELL_DAMAGE" or subevent == "SWING_DAMAGE" or subevent == "DAMAGE_SHIELD" or subevent == "RANGE_DAMAGE") and options.damaging.damage))  then
		    if (thresholdCheckDmg(dmgHeal)) then
				--print(MSG_CRITICAL_HIT:format(dmgHeal))
				PlaySoundFile("Interface\\AddOns\\SlapMeBoiiiiii\\AUDIO\\hit\\slap-"..tostring(math.random(1,options.max_hit))..".ogg","master")
				return true
			end
        end
	end

    if ( (destGUID == playerGUID or (petGUID  == destGUID and options.pet)) and options.rcvDmg.enabled) then
	    if (subeventCheckRcvdDmg(subevent,dmgHeal)) then
            PlaySoundFile("Interface\\AddOns\\SlapMeBoiiiiii\\AUDIO\\res\\pohui_"..tostring(math.random(1,options.max_res))..".ogg","master")
            return true
        end
	end
end

